<template>
  <div>
    <AtomAlert
      v-if="fetchError"
      class="fr-mb-2w"
      :alert-type="AlertType.Error"
      :message="fetchError"
    />
    <AtomLoader
      v-else-if="pending"
      class="fr-mx-auto"
    />
    <AtomFilters
      v-else
      :filters="filters"
      :initial-selected-values="INITIAL_VALUES"
      @filter="onFilter"
    />
  </div>
</template>

<script setup>
  import {
    ageGroupToDateRange,
    agentToAgentOption,
    toOptions,
    withEmptyValue
  } from '~/utils'
  import { STATUS_OPTIONS } from '~/utils/constants/beneficiary'
  import { AGE_GROUP_OPTIONS } from '~/utils/constants/age-groups'
  import { FilterType } from '~/utils/constants/filters'
  import { AlertType } from '~~/utils/constants/alert'
  import { useFiltersStore } from '~/store/filters'

  const FOLLOW_UP_TYPE_NAME = 'follow-up-type'
  const AGE_GROUP_NAME = 'age-group'
  const REFERENTS_NAME = 'referents'

  const emit = defineEmits(['filter'])

  const {
    $loadOrganisationFollowUpTypes,
    $loadAgents,
    $loadBeneficiariesCities
  } = useNuxtApp()
  const filtersStore = useFiltersStore()
  const INITIAL_VALUES = filtersStore.beneficiary.selectedFilters || {}

  const {
    data: followUpTypeOptions,
    pending: followUpTypeOptionsPending,
    error: followUpTypeOptionsError
  } = useLazyAsyncData('followUpTypeOptions', loadFollowUpTypeOptions, {
    server: false
  })

  const {
    data: agentOptions,
    pending: agentOptionsPending,
    error: agentOptionsError
  } = useLazyAsyncData('agentOptions', loadAgentOptions, {
    server: false
  })

  const {
    data: citiesOptions,
    pending: citiesOptionsPending,
    error: citiesOptionsError
  } = useLazyAsyncData('citiesOptions', loadCitiesOptions, {
    server: false
  })

  const pending = computed(
    () =>
      followUpTypeOptionsPending.value ||
      agentOptionsPending.value ||
      citiesOptionsPending.value
  )

  const fetchError = computed(() => {
    if (followUpTypeOptionsError.value) {
      return "La liste des types d'accompagnement n'a pas pu être chargée."
    }
    if (agentOptionsError.value) {
      return "La liste des agents n'a pas pu être chargée."
    }
    if (citiesOptionsError.value) {
      return "La liste des villes n'a pas pu être chargée."
    }
    return ''
  })

  async function loadFollowUpTypeOptions() {
    const followUpTypes = await $loadOrganisationFollowUpTypes()
    return toOptions(followUpTypes, 'id', 'name')
  }

  async function loadAgentOptions() {
    const agents = await $loadAgents()
    return new Map(agents.map(agentToAgentOption))
  }

  async function loadCitiesOptions() {
    const cities = await $loadBeneficiariesCities()
    return toOptions(cities, 'city', 'city')
  }

  const filters = computed(() => {
    if (
      !followUpTypeOptions.value ||
      !agentOptions.value ||
      !citiesOptions.value
    ) {
      return null
    }

    const filters = [
      {
        name: FOLLOW_UP_TYPE_NAME,
        label: "Type d'accompagnement",
        options: followUpTypeOptions.value,
        type: FilterType.SelectMultiple
      },
      {
        name: REFERENTS_NAME,
        label: 'Référent',
        options: agentOptions.value,
        type: FilterType.SelectMultiple
      }
    ]

    if (citiesOptions.value.size) {
      filters.push({
        name: 'city',
        label: 'Ville',
        options: citiesOptions.value,
        type: FilterType.SelectMultiple
      })
    }

    filters.push(
      ...[
        {
          name: 'status',
          label: 'Statut',
          options: withEmptyValue(STATUS_OPTIONS, 'Tous les statuts'),
          type: FilterType.SelectOne
        },
        {
          name: AGE_GROUP_NAME,
          label: "Tranche d'âge",
          options: withEmptyValue(
            AGE_GROUP_OPTIONS,
            "Toutes les tranches d'âge"
          ),
          type: FilterType.SelectOne
        }
      ]
    )

    return filters
  })

  function onFilter(_filters) {
    if (!_filters) return emit('filter', null)

    const selectedFilters = {}

    Object.entries(_filters).forEach(([name, value]) => {
      if (!value) return
      const filter = filters.value.find(f => f.name === name)

      if (name === FOLLOW_UP_TYPE_NAME) {
        selectedFilters._or = [
          {
            follow_ups: {
              follow_up_types: { follow_up_types_id: { _in: value } }
            }
          },
          { help_requests: { follow_up_type: { id: { _in: value } } } }
        ]
      } else if (name === AGE_GROUP_NAME) {
        const { lower, upper } = ageGroupToDateRange(value)
        if (lower && upper) {
          selectedFilters.birthdate = {
            _between: [lower.format('YYYY-MM-DD'), upper.format('YYYY-MM-DD')]
          }
        } else if (lower) {
          selectedFilters.birthdate = { _gte: lower.format('YYYY-MM-DD') }
        } else if (upper) {
          selectedFilters.birthdate = { _lte: upper.format('YYYY-MM-DD') }
        }
      } else if (name === REFERENTS_NAME) {
        selectedFilters.referents = { referent: { _in: value } }
      } else if (filter.type === FilterType.SelectMultiple) {
        selectedFilters[name] = { _in: value }
      } else selectedFilters[name] = { _eq: value }
    })

    filtersStore.beneficiary = {
      directusQuery: selectedFilters,
      selectedFilters: _filters
    }

    emit('filter', selectedFilters)
  }
</script>
